Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
x
$(() => {
const URL = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
const ordersStore = new DevExpress.data.CustomStore({
key: 'OrderID',
load() {
return sendRequest(`${URL}/Orders`);
},
insert(values) {
return sendRequest(`${URL}/InsertOrder`, 'POST', {
values: JSON.stringify(values),
});
},
update(key, values) {
return sendRequest(`${URL}/UpdateOrder`, 'PUT', {
key,
values: JSON.stringify(values),
});
},
remove(key) {
return sendRequest(`${URL}/DeleteOrder`, 'DELETE', {
key,
});
},
});
const dataGrid = $('#grid').dxDataGrid({
dataSource: ordersStore,
repaintChangesOnly: true,
showBorders: true,
editing: {
refreshMode: 'reshape',
mode: 'cell',
allowAdding: true,
allowUpdating: true,
allowDeleting: true,
},
scrolling: {
mode: 'virtual',
},
columns: [{
dataField: 'CustomerID',
caption: 'Customer',
lookup: {
dataSource: {
paginate: true,
store: new DevExpress.data.CustomStore({
key: 'Value',
loadMode: 'raw',
load() {
return sendRequest(`${URL}/CustomersLookup`);
},
}),
},
valueExpr: 'Value',
displayExpr: 'Text',
},
}, {
dataField: 'OrderDate',
dataType: 'date',
}, {
dataField: 'Freight',
}, {
dataField: 'ShipCountry',
}, {
dataField: 'ShipVia',
caption: 'Shipping Company',
dataType: 'number',
lookup: {
dataSource: new DevExpress.data.CustomStore({
key: 'Value',
loadMode: 'raw',
load() {
return sendRequest(`${URL}/ShippersLookup`);
},
}),
valueExpr: 'Value',
displayExpr: 'Text',
},
},
],
summary: {
totalItems: [{
column: 'CustomerID',
summaryType: 'count',
}, {
column: 'Freight',
valueFormat: '#0.00',
summaryType: 'sum',
}],
},
}).dxDataGrid('instance');
$('#refresh-mode').dxSelectBox({
items: ['full', 'reshape', 'repaint'],
value: 'reshape',
inputAttr: { 'aria-label': 'Refresh Mode' },
onValueChanged(e) {
dataGrid.option('editing.refreshMode', e.value);
},
});
$('#clear').dxButton({
text: 'Clear',
onClick() {
$('#requests ul').empty();
},
});
function sendRequest(url, method = 'GET', data) {
const d = $.Deferred();
logRequest(method, url, data);
$.ajax(url, {
method,
data,
cache: false,
xhrFields: { withCredentials: true },
}).done((result) => {
d.resolve(method === 'GET' ? result.data : result);
}).fail((xhr) => {
d.reject(xhr.responseJSON ? xhr.responseJSON.Message : xhr.statusText);
});
return d.promise();
}
function logRequest(method, url, data) {
const args = Object.keys(data || {}).map((key) => `${key}=${data[key]}`).join(' ');
const logList = $('#requests ul');
const time = DevExpress.localization.formatDate(new Date(), 'HH:mm:ss');
const newItem = $('<li>').text([time, method, url.slice(URL.length), args].join(' '));
logList.prepend(newItem);
}
});
xxxxxxxxxx
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head></head>
<body class="dx-viewport">
<div class="demo-container">
<div id="grid"></div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Refresh Mode:</span>
<div id="refresh-mode"></div>
</div>
<div id="requests">
<div>
<div class="caption">Network Requests</div>
<div id="clear"></div>
</div>
<ul></ul>
</div>
</div>
</div>
</body>
</html>
xxxxxxxxxx
#grid {
height: 440px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
margin-bottom: 10px;
font-weight: 500;
font-size: 18px;
}
.option {
margin-bottom: 10px;
}
.option > span {
position: relative;
top: 2px;
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
#requests .caption {
float: left;
padding-top: 7px;
}
#requests > div {
padding-bottom: 5px;
}
#requests > div::after {
content: "";
display: table;
clear: both;
}
#requests #clear {
float: right;
}
#requests ul {
list-style: none;
max-height: 100px;
overflow: auto;
margin: 0;
}
#requests ul li {
padding: 7px 0;
border-bottom: 1px solid #ddd;
}
#requests ul li:last-child {
border-bottom: none;
}
xxxxxxxxxx
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using Newtonsoft.Json;
using System;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
using DevExtreme.MVC.Demos.Models.Northwind;
using DevExtreme.MVC.Demos.Models.DataGrid;
using System.Collections.Generic;
namespace DevExtreme.MVC.Demos.Controllers {
[Route("api/DataGridWebApi/{action}", Name = "DataGridWebApi")]
public class DataGridWebApiController : ApiController {
InMemoryNorthwindContext _nwind = new InMemoryNorthwindContext();
[HttpGet]
public HttpResponseMessage Orders(DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(_nwind.Orders, loadOptions));
}
[HttpPost]
public HttpResponseMessage InsertOrder(FormDataCollection form) {
var values = form.Get("values");
var newOrder = new Order();
JsonConvert.PopulateObject(values, newOrder);
Validate(newOrder);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_nwind.Orders.Add(newOrder);
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.Created, newOrder);
}
[HttpPut]
public HttpResponseMessage UpdateOrder(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var order = _nwind.Orders.First(o => o.OrderID == key);
JsonConvert.PopulateObject(values, order);
Validate(order);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK, order);
}
[HttpDelete]
public void DeleteOrder(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var order = _nwind.Orders.First(o => o.OrderID == key);
_nwind.Orders.Remove(order);
_nwind.SaveChanges();
}
// additional actions
[HttpGet]
public HttpResponseMessage OrderDetails(int orderID, DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(
from i in _nwind.Order_Details
where i.OrderID == orderID
select new {
Product = i.Product.ProductName,
Price = i.UnitPrice,
i.Quantity,
Sum = i.UnitPrice * i.Quantity
},
loadOptions
));
}
[HttpGet]
public HttpResponseMessage ShippersLookup(DataSourceLoadOptions loadOptions) {
var lookup = from i in _nwind.Shippers
orderby i.CompanyName
select new {
Value = i.ShipperID,
Text = i.CompanyName
};
return Request.CreateResponse(DataSourceLoader.Load(lookup, loadOptions));
}
[HttpGet]
public HttpResponseMessage CustomersLookup(DataSourceLoadOptions loadOptions) {
var lookup = from i in _nwind.Customers
let text = i.CompanyName + " (" + i.Country + ")"
orderby i.CompanyName
select new {
Value = i.CustomerID,
Text = text
};
return Request.CreateResponse(DataSourceLoader.Load(lookup, loadOptions));
}
[HttpPost]
public HttpResponseMessage Batch(List<DataChange> changes) {
foreach(var change in changes) {
Order order;
if(change.Type == "update" || change.Type == "remove") {
var key = Convert.ToInt32(change.Key);
order = _nwind.Orders.First(o => o.OrderID == key);
} else {
order = new Order();
}
if(change.Type == "insert" || change.Type == "update") {
JsonConvert.PopulateObject(change.Data.ToString(), order);
Validate(order);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
if(change.Type == "insert") {
_nwind.Orders.Add(order);
}
change.Data = order;
} else if(change.Type == "remove") {
_nwind.Orders.Remove(order);
}
}
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK, changes);
}
}
}
xxxxxxxxxx
using System;
using System.Collections.Generic;
using System.Data.Entity;
namespace DevExtreme.MVC.Demos.Models.Northwind {
public class InMemoryNorthwindContext : InMemoryDataContext<Order> {
readonly NorthwindContext _nwind = new NorthwindContext();
public DbSet<Customer> Customers => _nwind.Customers;
public DbSet<Order_Detail> Order_Details => _nwind.Order_Details;
public ICollection<Order> Orders => ItemsInternal;
public DbSet<Shipper> Shippers => _nwind.Shippers;
protected override IEnumerable<Order> Source => _nwind.Orders;
protected override int GetKey(Order item) => item.OrderID;
protected override void SetKey(Order item, int key) => item.OrderID = key;
}
}

<dx-data-grid
id="grid"
[dataSource]="dataSource"
[repaintChangesOnly]="true"
[showBorders]="true"
>
<dxo-scrolling mode="virtual"></dxo-scrolling>
<dxo-editing
mode="cell"
[refreshMode]="refreshMode"
[allowAdding]="true"
[allowUpdating]="true"
[allowDeleting]="true"
>
</dxo-editing>
<dxi-column dataField="CustomerID" caption="Customer">
<dxo-lookup
[dataSource]="customersData"
valueExpr="Value"
displayExpr="Text"
></dxo-lookup>
</dxi-column>
<dxi-column dataField="OrderDate" dataType="date"></dxi-column>
<dxi-column dataField="Freight"></dxi-column>
<dxi-column dataField="ShipCountry"></dxi-column>
<dxi-column dataField="ShipVia" caption="Shipping Company" dataType="number">
<dxo-lookup
[dataSource]="shippersData"
valueExpr="Value"
displayExpr="Text"
></dxo-lookup>
</dxi-column>
<dxo-summary>
<dxi-total-item column="CustomerID" summaryType="count"> </dxi-total-item>
<dxi-total-item column="Freight" summaryType="sum" valueFormat="#0.00">
</dxi-total-item>
</dxo-summary>
</dx-data-grid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Refresh Mode:</span>
<dx-select-box [(value)]="refreshMode" [items]="refreshModes">
</dx-select-box>
</div>
<div id="requests">
<div>
<div class="caption">Network Requests</div>
<dx-button id="clear" text="Clear" (onClick)="clearRequests()">
</dx-button>
</div>
<ul>
<li *ngFor="let request of requests">{{ request }}</li>
</ul>
</div>
</div>
import {
NgModule, Component, enableProdMode, ChangeDetectionStrategy,
} from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import {
HttpClient, HttpClientModule, HttpHeaders, HttpParams,
} from '@angular/common/http';
import { DxDataGridModule, DxSelectBoxModule, DxButtonModule } from 'devextreme-angular';
import CustomStore from 'devextreme/data/custom_store';
import { formatDate } from 'devextreme/localization';
import { lastValueFrom } from 'rxjs';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
const URL = 'https://js.devexpress.com/Demos/Mvc/api/DataGridWebApi';
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
preserveWhitespaces: true,
})
export class AppComponent {
dataSource: any;
customersData: any;
shippersData: any;
refreshModes: string[];
refreshMode: string;
requests: string[] = [];
constructor(private http: HttpClient) {
this.refreshMode = 'reshape';
this.refreshModes = ['full', 'reshape', 'repaint'];
this.dataSource = new CustomStore({
key: 'OrderID',
load: () => this.sendRequest(`${URL}/Orders`),
insert: (values) => this.sendRequest(`${URL}/InsertOrder`, 'POST', {
values: JSON.stringify(values),
}),
update: (key, values) => this.sendRequest(`${URL}/UpdateOrder`, 'PUT', {
key,
values: JSON.stringify(values),
}),
remove: (key) => this.sendRequest(`${URL}/DeleteOrder`, 'DELETE', {
key,
}),
});
this.customersData = {
paginate: true,
store: new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => this.sendRequest(`${URL}/CustomersLookup`),
}),
};
this.shippersData = new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => this.sendRequest(`${URL}/ShippersLookup`),
});
}
sendRequest(url: string, method = 'GET', data: any = {}): any {
this.logRequest(method, url, data);
const httpParams = new HttpParams({ fromObject: data });
const httpOptions = { withCredentials: true, body: httpParams };
let result;
switch (method) {
case 'GET':
result = this.http.get(url, httpOptions);
break;
case 'PUT':
result = this.http.put(url, httpParams, httpOptions);
break;
case 'POST':
result = this.http.post(url, httpParams, httpOptions);
break;
case 'DELETE':
result = this.http.delete(url, httpOptions);
break;
}
return lastValueFrom(result)
.then((data: any) => (method === 'GET' ? data.data : data))
.catch((e) => {
throw e && e.error && e.error.Message;
});
}
logRequest(method: string, url: string, data: object): void {
const args = Object.keys(data || {}).map((key) => `${key}=${data[key]}`).join(' ');
const time = formatDate(new Date(), 'HH:mm:ss');
this.requests.unshift([time, method, url.slice(URL.length), args].join(' '));
}
clearRequests() {
this.requests = [];
}
}
@NgModule({
imports: [
BrowserModule,
DxDataGridModule,
DxSelectBoxModule,
DxButtonModule,
HttpClientModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #grid {
height: 440px;
}
::ng-deep .options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
::ng-deep .caption {
margin-bottom: 10px;
font-weight: 500;
font-size: 18px;
}
::ng-deep .option {
margin-bottom: 10px;
}
::ng-deep .option > span {
position: relative;
top: 2px;
margin-right: 10px;
}
::ng-deep .option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
::ng-deep #requests .caption {
float: left;
padding-top: 7px;
}
::ng-deep #requests > div {
padding-bottom: 5px;
}
::ng-deep #requests > div::after {
content: "";
display: table;
clear: both;
}
::ng-deep #requests #clear {
float: right;
}
::ng-deep #requests ul {
list-style: none;
max-height: 100px;
overflow: auto;
margin: 0;
}
::ng-deep #requests ul li {
padding: 7px 0;
border-bottom: 1px solid #ddd;
}
::ng-deep #requests ul li:last-child {
border-bottom: none;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.16',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.16',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.16',
'@angular/forms': 'npm:@angular/forms@12.2.16',
'@angular/common': 'npm:@angular/common@12.2.16',
'@angular/compiler': 'npm:@angular/compiler@12.2.16',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.2.3/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.18/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37',
'devextreme-angular': 'npm:devextreme-angular@22.2.3',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.16/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.2.3/*/package.json',
'npm:devextreme-angular@22.2.3/ui/*/package.json',
'npm:devextreme-angular@22.2.3/package.json',
'npm:devexpress-diagram@2.1.65/package.json',
'npm:devexpress-gantt@4.1.37/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using Newtonsoft.Json;
using System;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
using DevExtreme.MVC.Demos.Models.Northwind;
using DevExtreme.MVC.Demos.Models.DataGrid;
using System.Collections.Generic;
namespace DevExtreme.MVC.Demos.Controllers {
[Route("api/DataGridWebApi/{action}", Name = "DataGridWebApi")]
public class DataGridWebApiController : ApiController {
InMemoryNorthwindContext _nwind = new InMemoryNorthwindContext();
[HttpGet]
public HttpResponseMessage Orders(DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(_nwind.Orders, loadOptions));
}
[HttpPost]
public HttpResponseMessage InsertOrder(FormDataCollection form) {
var values = form.Get("values");
var newOrder = new Order();
JsonConvert.PopulateObject(values, newOrder);
Validate(newOrder);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_nwind.Orders.Add(newOrder);
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.Created, newOrder);
}
[HttpPut]
public HttpResponseMessage UpdateOrder(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var order = _nwind.Orders.First(o => o.OrderID == key);
JsonConvert.PopulateObject(values, order);
Validate(order);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK, order);
}
[HttpDelete]
public void DeleteOrder(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var order = _nwind.Orders.First(o => o.OrderID == key);
_nwind.Orders.Remove(order);
_nwind.SaveChanges();
}
// additional actions
[HttpGet]
public HttpResponseMessage OrderDetails(int orderID, DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(
from i in _nwind.Order_Details
where i.OrderID == orderID
select new {
Product = i.Product.ProductName,
Price = i.UnitPrice,
i.Quantity,
Sum = i.UnitPrice * i.Quantity
},
loadOptions
));
}
[HttpGet]
public HttpResponseMessage ShippersLookup(DataSourceLoadOptions loadOptions) {
var lookup = from i in _nwind.Shippers
orderby i.CompanyName
select new {
Value = i.ShipperID,
Text = i.CompanyName
};
return Request.CreateResponse(DataSourceLoader.Load(lookup, loadOptions));
}
[HttpGet]
public HttpResponseMessage CustomersLookup(DataSourceLoadOptions loadOptions) {
var lookup = from i in _nwind.Customers
let text = i.CompanyName + " (" + i.Country + ")"
orderby i.CompanyName
select new {
Value = i.CustomerID,
Text = text
};
return Request.CreateResponse(DataSourceLoader.Load(lookup, loadOptions));
}
[HttpPost]
public HttpResponseMessage Batch(List<DataChange> changes) {
foreach(var change in changes) {
Order order;
if(change.Type == "update" || change.Type == "remove") {
var key = Convert.ToInt32(change.Key);
order = _nwind.Orders.First(o => o.OrderID == key);
} else {
order = new Order();
}
if(change.Type == "insert" || change.Type == "update") {
JsonConvert.PopulateObject(change.Data.ToString(), order);
Validate(order);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
if(change.Type == "insert") {
_nwind.Orders.Add(order);
}
change.Data = order;
} else if(change.Type == "remove") {
_nwind.Orders.Remove(order);
}
}
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK, changes);
}
}
}
using System;
using System.Collections.Generic;
using System.Data.Entity;
namespace DevExtreme.MVC.Demos.Models.Northwind {
public class InMemoryNorthwindContext : InMemoryDataContext<Order> {
readonly NorthwindContext _nwind = new NorthwindContext();
public DbSet<Customer> Customers => _nwind.Customers;
public DbSet<Order_Detail> Order_Details => _nwind.Order_Details;
public ICollection<Order> Orders => ItemsInternal;
public DbSet<Shipper> Shippers => _nwind.Shippers;
protected override IEnumerable<Order> Source => _nwind.Orders;
protected override int GetKey(Order item) => item.OrderID;
protected override void SetKey(Order item, int key) => item.OrderID = key;
}
}

<template>
<div>
<DxDataGrid
id="grid"
:show-borders="true"
:data-source="ordersData"
:repaint-changes-only="true"
>
<DxEditing
:refresh-mode="refreshMode"
:allow-adding="true"
:allow-updating="true"
:allow-deleting="true"
mode="cell"
/>
<DxColumn
data-field="CustomerID"
caption="Customer"
>
<DxLookup
:data-source="customersData"
value-expr="Value"
display-expr="Text"
/>
</DxColumn>
<DxColumn
data-field="OrderDate"
data-type="date"
/>
<DxColumn data-field="Freight"/>
<DxColumn data-field="ShipCountry"/>
<DxColumn
data-field="ShipVia"
caption="Shipping Company"
data-type="number"
>
<DxLookup
:data-source="shippersData"
value-expr="Value"
display-expr="Text"
/>
</DxColumn>
<DxScrolling mode="virtual"/>
<DxSummary>
<DxTotalItem
column="CustomerID"
summary-type="count"
/>
<DxTotalItem
column="Freight"
summary-type="sum"
value-format="#0.00"
/>
</DxSummary>
</DxDataGrid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Refresh Mode: </span>
<DxSelectBox
v-model:value="refreshMode"
:items="refreshModes"
/>
</div>
<div id="requests">
<div>
<div class="caption">Network Requests</div>
<DxButton
id="clear"
text="Clear"
@click="clearRequests()"
/>
</div>
<ul>
<li
v-for="(request, index) in requests"
:key="index"
>{{ request }}</li>
</ul>
</div>
</div>
</div>
</template>
<script>
import {
DxDataGrid,
DxColumn,
DxEditing,
DxScrolling,
DxSummary,
DxLookup,
DxTotalItem
} from 'devextreme-vue/data-grid';
import { DxButton } from 'devextreme-vue/button';
import { DxSelectBox } from 'devextreme-vue/select-box';
import CustomStore from 'devextreme/data/custom_store';
import { formatDate } from 'devextreme/localization';
import 'whatwg-fetch';
const URL = 'https://js.devexpress.com/Demos/Mvc/api/DataGridWebApi';
export default {
components: {
DxDataGrid,
DxColumn,
DxEditing,
DxScrolling,
DxSummary,
DxLookup,
DxTotalItem,
DxButton,
DxSelectBox
},
data() {
return {
ordersData: new CustomStore({
key: 'OrderID',
load: () => this.sendRequest(`${URL}/Orders`),
insert: (values) => this.sendRequest(`${URL}/InsertOrder`, 'POST', {
values: JSON.stringify(values)
}),
update: (key, values) => this.sendRequest(`${URL}/UpdateOrder`, 'PUT', {
key: key,
values: JSON.stringify(values)
}),
remove: (key) => this.sendRequest(`${URL}/DeleteOrder`, 'DELETE', {
key: key
})
}),
customersData: new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => this.sendRequest(`${URL}/CustomersLookup`)
}),
shippersData: new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => this.sendRequest(`${URL}/ShippersLookup`)
}),
requests: [],
refreshMode: 'reshape',
refreshModes: ['full', 'reshape', 'repaint']
};
},
methods: {
sendRequest(url, method, data) {
method = method || 'GET';
data = data || {};
this.logRequest(method, url, data);
const params = Object.keys(data).map((key) => {
return `${encodeURIComponent(key) }=${ encodeURIComponent(data[key])}`;
}).join('&');
if(method === 'GET') {
return fetch(url, {
method: method,
credentials: 'include'
}).then(result => result.json().then(json => {
if(result.ok) return json.data;
throw json.Message;
}));
}
return fetch(url, {
method: method,
body: params,
headers: {
'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8'
},
credentials: 'include'
}).then(result => {
if(result.ok) {
return result.text().then(text => text && JSON.parse(text));
} else {
return result.json().then(json => {
throw json.Message;
});
}
});
},
logRequest(method, url, data) {
var args = Object.keys(data || {}).map(function(key) {
return `${key }=${ data[key]}`;
}).join(' ');
var time = formatDate(new Date(), 'HH:mm:ss');
this.requests.unshift([time, method, url.slice(URL.length), args].join(' '));
},
clearRequests() {
this.requests = [];
}
},
};
</script>
<style scoped>
#grid {
height: 440px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
margin-bottom: 10px;
font-weight: 500;
font-size: 18px;
}
.option {
margin-bottom: 10px;
}
.option > span {
position: relative;
top: 2px;
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
#requests .caption {
float: left;
padding-top: 7px;
}
#requests > div {
padding-bottom: 5px;
}
#requests > div:after {
content: "";
display: table;
clear: both;
}
#requests #clear {
float: right;
}
#requests ul {
list-style: none;
max-height: 100px;
overflow: auto;
margin: 0;
}
#requests ul li {
padding: 7px 0;
border-bottom: 1px solid #dddddd;
}
#requests ul li:last-child {
border-bottom: none;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"/>
</div>
</body>
</html>
System.config({
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader'
},
'devextreme/localization.js': {
"esModule": true
},
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.5',
'devextreme-vue': 'npm:devextreme-vue@20.2.5',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.11/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.18/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.11/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.11/hooks/dist/hooks.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});

import React from 'react';
import { DataGrid, Column, Editing, Scrolling, Lookup, Summary, TotalItem } from 'devextreme-react/data-grid';
import { Button } from 'devextreme-react/button';
import { SelectBox } from 'devextreme-react/select-box';
import CustomStore from 'devextreme/data/custom_store';
import { formatDate } from 'devextreme/localization';
import 'whatwg-fetch';
const URL = 'https://js.devexpress.com/Demos/Mvc/api/DataGridWebApi';
const REFRESH_MODES = ['full', 'reshape', 'repaint'];
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
ordersData: new CustomStore({
key: 'OrderID',
load: () => this.sendRequest(`${URL}/Orders`),
insert: (values) => this.sendRequest(`${URL}/InsertOrder`, 'POST', {
values: JSON.stringify(values)
}),
update: (key, values) => this.sendRequest(`${URL}/UpdateOrder`, 'PUT', {
key: key,
values: JSON.stringify(values)
}),
remove: (key) => this.sendRequest(`${URL}/DeleteOrder`, 'DELETE', {
key: key
})
}),
customersData: new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => this.sendRequest(`${URL}/CustomersLookup`)
}),
shippersData: new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => this.sendRequest(`${URL}/ShippersLookup`)
}),
requests: [],
refreshMode: 'reshape'
};
this.clearRequests = this.clearRequests.bind(this);
this.handleRefreshModeChange = this.handleRefreshModeChange.bind(this);
}
sendRequest(url, method, data) {
method = method || 'GET';
data = data || {};
this.logRequest(method, url, data);
if(method === 'GET') {
return fetch(url, {
method: method,
credentials: 'include'
}).then(result => result.json().then(json => {
if(result.ok) return json.data;
throw json.Message;
}));
}
const params = Object.keys(data).map((key) => {
return `${encodeURIComponent(key) }=${ encodeURIComponent(data[key])}`;
}).join('&');
return fetch(url, {
method: method,
body: params,
headers: {
'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8'
},
credentials: 'include'
}).then(result => {
if(result.ok) {
return result.text().then(text => text && JSON.parse(text));
} else {
return result.json().then(json => {
throw json.Message;
});
}
});
}
logRequest(method, url, data) {
const args = Object.keys(data || {}).map(function(key) {
return `${key }=${ data[key]}`;
}).join(' ');
const time = formatDate(new Date(), 'HH:mm:ss');
const request = [time, method, url.slice(URL.length), args].join(' ');
this.setState((state) => {
return { requests: [request].concat(state.requests) };
});
}
clearRequests() {
this.setState({ requests: [] });
}
handleRefreshModeChange(e) {
this.setState({ refreshMode: e.value });
}
render() {
const { refreshMode, ordersData, customersData, shippersData } = this.state;
return (
<React.Fragment>
<DataGrid
id="grid"
showBorders={true}
dataSource={ordersData}
repaintChangesOnly={true}
>
<Editing
refreshMode={refreshMode}
mode="cell"
allowAdding={true}
allowDeleting={true}
allowUpdating={true}
/>
<Scrolling
mode="virtual"
/>
<Column dataField="CustomerID" caption="Customer">
<Lookup dataSource={customersData} valueExpr="Value" displayExpr="Text" />
</Column>
<Column dataField="OrderDate" dataType="date">
</Column>
<Column dataField="Freight">
</Column>
<Column dataField="ShipCountry">
</Column>
<Column
dataField="ShipVia"
caption="Shipping Company"
dataType="number"
>
<Lookup dataSource={shippersData} valueExpr="Value" displayExpr="Text" />
</Column>
<Summary>
<TotalItem column="CustomerID" summaryType="count" />
<TotalItem column="Freight" summaryType="sum" valueFormat="#0.00" />
</Summary>
</DataGrid>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Refresh Mode: </span>
<SelectBox
value={refreshMode}
items={REFRESH_MODES}
onValueChanged={this.handleRefreshModeChange}
/>
</div>
<div id="requests">
<div>
<div className="caption">Network Requests</div>
<Button id="clear" text="Clear" onClick={this.clearRequests} />
</div>
<ul>
{this.state.requests.map((request, index) => <li key={index}>{request}</li>)}
</ul>
</div>
</div>
</React.Fragment>
);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app')
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#grid {
height: 440px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
margin-bottom: 10px;
font-weight: 500;
font-size: 18px;
}
.option {
margin-bottom: 10px;
}
.option > span {
position: relative;
top: 2px;
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
#requests .caption {
float: left;
padding-top: 7px;
}
#requests > div {
padding-bottom: 5px;
}
#requests > div:after {
content: "";
display: table;
clear: both;
}
#requests #clear {
float: right;
}
#requests ul {
list-style: none;
max-height: 100px;
overflow: auto;
margin: 0;
}
#requests ul li {
padding: 7px 0;
border-bottom: 1px solid #dddddd;
}
#requests ul li:last-child {
border-bottom: none;
}
System.config({
transpiler: 'plugin-babel',
meta: {
},
paths: {
'npm:': 'https://unpkg.com/'
},
defaultExtension: 'js',
map: {
'react': 'npm:react@16.14.0/umd/react.development.js',
'react-dom': 'npm:react-dom@16.14.0/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.7.2/prop-types.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'devextreme-react': 'npm:devextreme-react@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme': {
defaultExtension: 'js'
},
'devextreme-react': {
main: 'index.js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true,
react: true
}
});